﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Algobox.Objects.Finance.Assets
{
    public interface ITick
    {
        string Name { get; }

        decimal Round(decimal price);
        decimal Round(double price);

        decimal GetTickSize(decimal price);
        decimal GetTickSize(double price);
    }
}
