﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;
using System.Collections.Concurrent;

namespace Algobox.Structure.Finance.Strategies.FractionPrototype
{
    public interface IFractionData
    {
        IDictionary<string, StockSecurity> Stocks { get; }
        string FeedName { get; }
        bool TryLoadStrategyFraction(string username, FractionManagement manager);
        bool TrySaveStrategyFraction(string username, FractionManagement manager);
        StockSecurity AddStock(string symbol);  
    }
}
