﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;
using System.Collections.Concurrent;

namespace Algobox.Structure.Finance.Strategies.Dastan
{
    public interface IDastanData
    {
        IDictionary<string, StockSecurity> Stocks { get; }
        string FeedName { get; }
        bool TryLoadStrategyDastan(DastanManagement manager);
        bool TrySaveStrategyDastan(DastanManagement manager);   
    }
}
