﻿using System;
using Algobox.Objects.Finance.Assets.Stock;
namespace Algobox.Structure.Finance.Strategies.FractionPrototype
{
    public interface IFractionComponent
    {
        FractionManagement Manager { get; }
        StockSecurity Security { get; }
        StockSecurity SecurityPair { get; }        
        string SymbolA { get; }
        string SymbolB { get; }
        double CloseA { get; }
        double CloseB { get; }
        ushort Value { get; }
        double Trigger { get; }
        double Exit { get; }

        void OnFractionTriggerComplete(FractionTrigger leg);
    }
}
