﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;
using System.Collections.Concurrent;

namespace Algobox.Structure.Finance.Strategies.Moss
{
    public interface IMossData
    {
        IDictionary<string, StockSecurity> Stocks { get; }
        string FeedName { get; }
        bool TryLoadStrategyMoss(string username, MossManagement manager);
        bool TrySaveStrategyMoss(string username, MossManagement manager);   
    }
}
