﻿//
// © Algobox Ltd - Benn Eichhorn
//
using System;
using Algobox.Objects.Finance.Assets.Stock;
using System.Collections.Generic;

namespace Algobox.Structure.Finance.Strategies.SpikeArb
{
    public interface ISpikeArbData
    {
        IDictionary<string, StockSecurity> Stocks { get; }

        string FeedName { get; }
        bool TryLoadStrategySpikeArb(Algobox.Structure.Finance.Strategies.SpikeArb.SpikeArbManagement spikeArb);
        bool TrySaveStrategySpikeArb(Algobox.Structure.Finance.Strategies.SpikeArb.SpikeArbManagement spikeArb);
    }
}
