﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Algobox.Objects.Finance.Assets.Stock;
using System.Collections.Concurrent;

namespace Algobox.Structure.Finance.Strategies.Terrapin
{
    public interface ITerrapinData
    {
        IDictionary<string, StockSecurity> Stocks { get; }
        string FeedName { get; }
        bool TryLoadStrategyTerrapin(TerrapinManagement manager);
        bool TrySaveStrategyTerrapin(TerrapinManagement manager);   
    }
}
